ALTER TABLE DB.ODCLEANSTORE.QA_RULES_GROUPS ADD COLUMN isUncommitted SMALLINT NOT NULL DEFAULT 0;
ALTER TABLE DB.ODCLEANSTORE.DN_RULES_GROUPS ADD COLUMN isUncommitted SMALLINT NOT NULL DEFAULT 0;
ALTER TABLE DB.ODCLEANSTORE.OI_RULES_GROUPS ADD COLUMN isUncommitted SMALLINT NOT NULL DEFAULT 0;

CREATE TABLE DB.ODCLEANSTORE.QA_RULES_UNCOMMITTED
(
	id INTEGER NOT NULL IDENTITY PRIMARY KEY,
	groupId INTEGER NOT NULL,
	filter LONG NVARCHAR NOT NULL,
	coefficient REAL NOT NULL,
	description LONG NVARCHAR,
	
	FOREIGN KEY (groupId) REFERENCES DB.ODCLEANSTORE.QA_RULES_GROUPS(id) ON DELETE CASCADE
);

CREATE TABLE DB.ODCLEANSTORE.DN_RULES_UNCOMMITTED
(
	id INTEGER NOT NULL IDENTITY PRIMARY KEY,
	groupId INTEGER NOT NULL,
	description LONG NVARCHAR,
	
	FOREIGN KEY (groupId) REFERENCES DB.ODCLEANSTORE.DN_RULES_GROUPS(id) ON DELETE CASCADE
);

CREATE TABLE DB.ODCLEANSTORE.DN_RULE_COMPONENTS_UNCOMMITTED
(
	id INTEGER NOT NULL IDENTITY PRIMARY KEY,
	ruleId INTEGER NOT NULL,
	typeId INTEGER NOT NULL,
	modification LONG NVARCHAR NOT NULL,
	description LONG NVARCHAR,
	
	FOREIGN KEY (ruleId) REFERENCES DB.ODCLEANSTORE.DN_RULES_UNCOMMITTED(id) ON DELETE CASCADE,
	FOREIGN KEY (typeId) REFERENCES DB.ODCLEANSTORE.DN_RULE_COMPONENT_TYPES(id) ON DELETE CASCADE
);

CREATE TABLE DB.ODCLEANSTORE.OI_RULES_UNCOMMITTED
(
	id INTEGER NOT NULL IDENTITY PRIMARY KEY,
	groupId INTEGER NOT NULL,
	label NVARCHAR(255) NOT NULL,
	linkType NVARCHAR(255) NOT NULL,
	sourceRestriction NVARCHAR(255),
	targetRestriction NVARCHAR(255),
	linkageRule LONG NVARCHAR NOT NULL,
	filterThreshold DECIMAL,
	filterLimit INTEGER, 
	
	FOREIGN KEY (groupId) REFERENCES DB.ODCLEANSTORE.OI_RULES_GROUPS(id) ON DELETE CASCADE
);

CREATE TABLE DB.ODCLEANSTORE.OI_OUTPUTS_UNCOMMITTED
(
	id INTEGER NOT NULL IDENTITY PRIMARY KEY,
	ruleId INTEGER NOT NULL,
	outputTypeId INTEGER NOT NULL,
	minConfidence DECIMAL,
	maxConfidence DECIMAL,
	fileName VARCHAR(255),
	fileFormatId INTEGER,

	FOREIGN KEY (ruleId) REFERENCES DB.ODCLEANSTORE.OI_RULES_UNCOMMITTED(id) ON DELETE CASCADE,
	FOREIGN KEY (outputTypeId) REFERENCES DB.ODCLEANSTORE.OI_OUTPUT_TYPES(id) ON DELETE CASCADE,
	FOREIGN KEY (fileFormatId) REFERENCES DB.ODCLEANSTORE.OI_FILE_FORMATS(id) ON DELETE CASCADE
);


INSERT INTO DB.ODCLEANSTORE.QA_RULES_UNCOMMITTED SELECT * FROM DB.ODCLEANSTORE.QA_RULES;
INSERT INTO DB.ODCLEANSTORE.DN_RULES_UNCOMMITTED SELECT * FROM DB.ODCLEANSTORE.DN_RULES;
INSERT INTO DB.ODCLEANSTORE.DN_RULE_COMPONENTS_UNCOMMITTED SELECT * FROM DB.ODCLEANSTORE.DN_RULE_COMPONENTS;
INSERT INTO DB.ODCLEANSTORE.OI_RULES_UNCOMMITTED SELECT * FROM DB.ODCLEANSTORE.OI_RULES;
INSERT INTO DB.ODCLEANSTORE.OI_OUTPUTS_UNCOMMITTED SELECT * FROM DB.ODCLEANSTORE.OI_OUTPUTS;


